/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.3 Revision 1.20
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2004 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.3 2004/11/27 11:26:52 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.20 2005/01/23 20:47:42 eradicator Exp $
4# 4#
5# This eclass provides functions for querying the installed kernel 5# Description: This eclass is used as a central eclass for accessing kernel
6# source version, selected kernel options etc. 6# related information for sources already installed.
7# It is vital for linux-mod to function correctly, and is split
8# out so that any ebuild behaviour "templates" are abstracted out
9# using additional eclasses.
7# 10#
11# Maintainer: John Mylchreest <johnm@gentoo.org>
12# Copyright 2004 Gentoo Linux
13#
14# Please direct your bugs to the current eclass maintainer :)
15
16# A Couple of env vars are available to effect usage of this eclass
17# These are as follows:
18#
19# Env Var Option Description
20# KERNEL_DIR <string> The directory containing kernel the target kernel
21# sources.
22# CONFIG_CHECK <string> a list of .config options to check for before
23# proceeding with the install. ie: CONFIG_CHECK="MTRR"
24# You can also check that an option doesn't exist by
25# prepending it with an exclamation mark (!).
26# ie: CONFIG_CHECK="!MTRR"
27# <CFG>_ERROR <string> The error message to display when the above check
28# fails. <CFG> should reference the appropriate option
29# as above. ie: MTRR_ERROR="MTRR exists in the .config
30# but shouldn't!!"
31# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from
32# the kernel makefile. This contains the directory
33# which is to be used as the kernel object directory.
34
35# There are also a couple of variables which are set by this, and shouldn't be
36# set by hand. These are as follows:
37#
38# Env Var Option Description
39# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1
40# KV_MAJOR <integer> The kernel major version. ie: 2
41# KV_MINOR <integer> The kernel minor version. ie: 6
42# KV_PATCH <integer> The kernel patch version. ie: 9
43# KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo
44# KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm
45# KV_DIR <string> The kernel source directory, will be null if
46# KERNEL_DIR is invalid.
47# KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless
48# koutput is used. This should be used for referencing
49# .config.
50
8 51
9ECLASS=linux-info 52ECLASS=linux-info
10INHERITED="$INHERITED $ECLASS" 53INHERITED="$INHERITED $ECLASS"
54EXPORT_FUNCTIONS pkg_setup
55
56inherit toolchain-funcs
11 57
12# Overwritable environment Var's 58# Overwritable environment Var's
13# --------------------------------------- 59# ---------------------------------------
14KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}" 60KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}"
15 61
16 62
63# Bug fixes
64
65# fix to bug #75034
66case ${ARCH} in
67 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
68 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
69esac
70
71# Pulled from eutils as it might be more useful only being here since
72# very few ebuilds which dont use this eclass will ever ever use these functions
73set_arch_to_kernel() {
74 export ARCH="$(tc-arch-kernel)"
75}
76
77# set's ARCH back to what portage expects
78set_arch_to_portage() {
79 export ARCH="$(tc-arch)"
80}
81
82
83#
84# qeinfo "Message"
85# -------------------
86# qeinfo is a queit einfo call when EBUILD_PHASE
87# should not have visible output.
88#
89qeinfo() {
90 local outputmsg
91 outputmsg="${@}"
92 case "${EBUILD_PHASE}" in
93 depend) unset outputmsg;;
94 clean) unset outputmsg;;
95 preinst) unset outputmsg;;
96 esac
97 [ -n "${outputmsg}" ] && einfo "${outputmsg}"
98}
99
100qeerror() {
101 local outputmsg
102 outputmsg="${@}"
103 case "${EBUILD_PHASE}" in
104 depend) unset outputmsg;;
105 clean) unset outputmsg;;
106 preinst) unset outputmsg;;
107 esac
108 [ -n "${outputmsg}" ] && einfo "${outputmsg}"
109}
110
111
17 112
18# File Functions 113# File Functions
19# --------------------------------------- 114# ---------------------------------------
20 115
21# getfilevar accepts 2 vars as follows: 116# getfilevar accepts 2 vars as follows:
22# getfilevar <VARIABLE> <CONFIGFILE> 117# getfilevar <VARIABLE> <CONFIGFILE>
23 118
24getfilevar() { 119getfilevar() {
25local ERROR 120local ERROR workingdir basefname basedname xarch
26 ERROR=0 121 ERROR=0
27 122
28 [ -z "${1}" ] && ERROR=1 123 [ -z "${1}" ] && ERROR=1
29 [ -z "${2}" ] && ERROR=1
30 [ ! -f "${2}" ] && ERROR=1 124 [ ! -f "${2}" ] && ERROR=1
31 125
32 if [ "${ERROR}" = 1 ] 126 if [ "${ERROR}" = 1 ]
33 then 127 then
128 ebeep
129 echo -e "\n"
34 eerror "getfilevar requires 2 variables, with the second a valid file." 130 eerror "getfilevar requires 2 variables, with the second a valid file."
35 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 131 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
36 else 132 else
37 grep -e "^$1[= ]" $2 | sed 's: = :=:' | cut -d= -f2- 133 workingdir=${PWD}
134 basefname=$(basename ${2})
135 basedname=$(dirname ${2})
136 xarch=${ARCH}
137 unset ARCH
138
139 cd ${basedname}
140 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
141 make ${BUILD_FIXES} -f - e 2>/dev/null
142 cd ${workingdir}
143
144 ARCH=${xarch}
38 fi 145 fi
39} 146}
40 147
41getfilevar_isset() { 148linux_chkconfig_present() {
42local RESULT 149local RESULT
43 RESULT="$(getfilevar ${1} ${2})" 150 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
44 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 151 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
45} 152}
46 153
47getfilevar_ismodule() { 154linux_chkconfig_module() {
48local RESULT 155local RESULT
49 RESULT="$(getfilevar ${1} ${2})" 156 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
50 [ "${RESULT}" = "m" ] && return 0 || return 1 157 [ "${RESULT}" = "m" ] && return 0 || return 1
51} 158}
52 159
53getfilevar_isbuiltin() { 160linux_chkconfig_builtin() {
54local RESULT 161local RESULT
55 RESULT="$(getfilevar ${1} ${2})" 162 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
56 [ "${RESULT}" = "y" ] && return 0 || return 1 163 [ "${RESULT}" = "y" ] && return 0 || return 1
164}
165
166linux_chkconfig_string() {
167 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config"
57} 168}
58 169
59# Versioning Functions 170# Versioning Functions
60# --------------------------------------- 171# ---------------------------------------
61 172
72 183
73kernel_is() { 184kernel_is() {
74 # if we haven't determined the version yet, we need too. 185 # if we haven't determined the version yet, we need too.
75 get_version; 186 get_version;
76 187
77 local RESULT 188 local RESULT operator test value i len
78 RESULT=1 189 RESULT=0
79 190
191 operator="="
192 if [ "${1}" == "lt" ]
193 then
194 operator="-lt"
195 shift
196 elif [ "${1}" == "gt" ]
197 then
198 operator="-gt"
199 shift
200 elif [ "${1}" == "le" ]
201 then
202 operator="-le"
203 shift
204 elif [ "${1}" == "ge" ]
205 then
206 operator="-ge"
207 shift
208 fi
209
80 if [ -n "${1}" ] 210 if [ -n "${1}" ]
81 then 211 then
82 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0 212 value="${value}${1}"
213 test="${test}${KV_MAJOR}"
83 fi 214 fi
84
85 if [ -n "${2}" ] 215 if [ -n "${2}" ]
86 then 216 then
87 RESULT=1 217 len=$[ 3 - ${#2} ]
88 [ "${2}" = "${KV_MINOR}" ] && RESULT=0 218 for((i=0; i<$len; i++)); do
219 value="${value}0"
220 done
221 value="${value}${2}"
222
223 len=$[ 3 - ${#KV_MINOR} ]
224 for((i=0; i<$len; i++)); do
225 test="${test}0"
226 done
227 test="${test}${KV_MINOR}"
89 fi 228 fi
90
91 if [ -n "${3}" ] 229 if [ -n "${3}" ]
92 then 230 then
93 RESULT=1 231 len=$[ 3 - ${#3} ]
94 [ "${3}" = "${KV_PATCH}" ] && RESULT=0 232 for((i=0; i<$len; i++)); do
233 value="${value}0"
234 done
235 value="${value}${3}"
236
237 len=$[ 3 - ${#KV_PATCH} ]
238 for((i=0; i<$len; i++)); do
239 test="${test}0"
240 done
241 test="${test}${KV_PATCH}"
95 fi 242 fi
96 return ${RESULT} 243
244 [ ${test} ${operator} ${value} ] && return 0 || return 1
97} 245}
98 246
99get_version() { 247get_version() {
248 local kbuild_output
249
100 # no need to execute this twice assuming KV_FULL is populated. 250 # no need to execute this twice assuming KV_FULL is populated.
101 # we can force by unsetting KV_FULL 251 # we can force by unsetting KV_FULL
102 if [ -n "${KV_FULL}" ] 252 [ -n "${KV_FULL}" ] && return 0
103 then
104 # Lets keep this quiet eh?
105 # einfo "\${KV_FULL} is already set. Not running get_version again"
106 return
107 fi
108 253
109 # if we dont know KV_FULL, then we need too. 254 # if we dont know KV_FULL, then we need too.
110 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 255 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
111 unset KV_DIR 256 unset KV_DIR
112 257
113 # KV_DIR will contain the full path to the sources directory we should use 258 # KV_DIR will contain the full path to the sources directory we should use
114 einfo "Determining the location of the kernel source code" 259 qeinfo "Determining the location of the kernel source code"
115 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 260 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
116 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 261 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
117 262
118 if [ -z "${KV_DIR}" ] 263 if [ -z "${KV_DIR}" ]
119 then 264 then
120 eerror "Unable to find kernel sources at ${KERNEL_DIR}" 265 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
121 die 266 qeinfo "This package requires Linux sources."
267 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
268 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
269 qeinfo "(or the kernel you wish to build against)."
270 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
271 else
272 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
122 fi 273 fi
274 return 1
275 fi
276
277 qeinfo "Found kernel source directory:"
278 qeinfo " ${KV_DIR}"
279
280 if [ ! -s "${KV_DIR}/Makefile" ]
281 then
282 qeerror "Could not find a Makefile in the kernel source directory."
283 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
284 return 1
285 fi
286
287 # OK so now we know our sources directory, but they might be using
288 # KBUILD_OUTPUT, and we need this for .config and localversions-*
289 # so we better find it eh?
290 # do we pass KBUILD_OUTPUT on the CLI?
291 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
292
293 # And if we didn't pass it, we can take a nosey in the Makefile
294 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)"
295 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
123 296
124 # And contrary to existing functions I feel we shouldn't trust the 297 # And contrary to existing functions I feel we shouldn't trust the
125 # directory name to find version information as this seems insane. 298 # directory name to find version information as this seems insane.
126 # so we parse ${KV_DIR}/Makefile 299 # so we parse ${KV_DIR}/Makefile
127 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 300 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)"
128 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 301 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)"
129 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 302 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)"
130 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 303 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)"
304
305 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
306 then
307 qeerror "Could not detect kernel version."
308 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
309 return 1
310 fi
311
131 # and in newer versions we can also pull LOCALVERSION if it is set. 312 # and in newer versions we can also pull LOCALVERSION if it is set.
132 KV_LOCAL="$(cat ${KV_DIR}/localversion* 2>/dev/null)$(getfilevar CONFIG_LOCALVERSION ${KV_DIR}/.config | sed 's:"::g')" 313 # but before we do this, we need to find if we use a different object directory.
314 # This *WILL* break if the user is using localversions, but we assume it was
315 # caught before this if they are.
316 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \
317 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}"
318
319 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
320 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
321 if [ -n "${KV_OUT_DIR}" ];
322 then
323 qeinfo "Found kernel object directory:"
324 qeinfo " ${KV_OUT_DIR}"
325
326 KV_LOCAL="$(cat ${KV_OUT_DIR}/localversion* 2>/dev/null)"
327 fi
328 # and if we STILL haven't got it, then we better just set it to KV_DIR
329 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
330
331 KV_LOCAL="${KV_LOCAL}$(cat ${KV_DIR}/localversion* 2>/dev/null)"
332 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
333 KV_LOCAL="${KV_LOCAL//\"/}"
133 334
134 # And we should set KV_FULL to the full expanded version 335 # And we should set KV_FULL to the full expanded version
135 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 336 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
136 337
137 if [ -z "${KV_FULL}" ]
138 then
139 eerror "We are unable to find a usable kernel source tree in ${KV_DIR}"
140 eerror "Please check a kernel source exists in this directory."
141 die
142 else
143 einfo "Found kernel source directory:"
144 einfo " ${KV_DIR}"
145 einfo "with sources for kernel version:" 338 qeinfo "Found sources for kernel version:"
146 einfo " ${KV_FULL}" 339 qeinfo " ${KV_FULL}"
340
341 if [ ! -s "${KV_OUT_DIR}/.config" ]
342 then
343 qeerror "Could not find a usable .config in the kernel source directory."
344 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
345 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
346 qeerror "it points to the necessary object directory so that it might find .config."
347 return 1
147 fi 348 fi
349
350 return 0
148} 351}
149 352
150 353
151 354
152 355
155 358
156check_kernel_built() { 359check_kernel_built() {
157 # if we haven't determined the version yet, we need too. 360 # if we haven't determined the version yet, we need too.
158 get_version; 361 get_version;
159 362
160 if [ ! -f "${KV_DIR}/System.map" ] 363 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
161 then 364 then
162 eerror "These sources have not yet been compiled." 365 eerror "These sources have not yet been prepared."
163 eerror "We cannot build against an uncompiled tree." 366 eerror "We cannot build against an unprepared tree."
164 eerror "To resolve this, please type the following:" 367 eerror "To resolve this, please type the following:"
165 eerror 368 eerror
166 eerror "# cd ${KV_DIR}" 369 eerror "# cd ${KV_DIR}"
167 eerror "# make oldconfig" 370 eerror "# make oldconfig"
168 eerror "# make bzImage modules modules_install" 371 eerror "# make modules_prepare"
169 eerror 372 eerror
170 eerror "Then please try merging this module again." 373 eerror "Then please try merging this module again."
171 die "Kernel sources need compiling first" 374 die "Kernel sources need compiling first"
172 fi 375 fi
173} 376}
174 377
175check_modules_supported() { 378check_modules_supported() {
176 # if we haven't determined the version yet, we need too. 379 # if we haven't determined the version yet, we need too.
177 get_version; 380 get_version;
178 381
179 getfilevar_isset CONFIG_MODULES ${KV_DIR}/.config 382 if ! linux_chkconfig_builtin "MODULES"
180 if [ "$?" != 0 ]
181 then 383 then
182 eerror "These sources do not support loading external modules." 384 eerror "These sources do not support loading external modules."
183 eerror "to be able to use this module please enable \"Loadable modules support\"" 385 eerror "to be able to use this module please enable \"Loadable modules support\""
184 eerror "in your kernel, recompile and then try merging this module again." 386 eerror "in your kernel, recompile and then try merging this module again."
185 die No support for external modules in ${KV_FUll} config 387 die "No support for external modules in ${KV_FULL} config"
186 fi 388 fi
187} 389}
188 390
189check_extra_config() { 391check_extra_config() {
190local config negate error 392 local config negate error local_error i n temp_config
191 393
192 # if we haven't determined the version yet, we need too. 394 # if we haven't determined the version yet, we need too.
193 get_version; 395 get_version;
194 396
195 einfo "Checking for suitable kernel configuration options" 397 einfo "Checking for suitable kernel configuration options"
197 do 399 do
198 negate="${config:0:1}" 400 negate="${config:0:1}"
199 if [ "${negate}" == "!" ]; 401 if [ "${negate}" == "!" ];
200 then 402 then
201 config="${config:1}" 403 config="${config:1}"
202 if getfilevar_isset ${config} ${KV_DIR}/.config ; 404 if linux_chkconfig_present ${config}
203 then 405 then
406 local_error="${config}_ERROR"
407 local_error="${!local_error}"
408 [ -n "${local_error}" ] && eerror " ${local_error}" || \
204 eerror " ${config}:\tshould not be set in the kernel configuration, but it is." 409 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
205 error=1 410 error=1
206 fi 411 fi
412 elif [ "${negate}" == "@" ];
413 then
414 # we never call this unless we are using MODULE_NAMES
415
416 config="${config:1}"
417 temp_config="${config//*:}"
418 config="${config//:*}"
419 if linux_chkconfig_present ${config}
420 then
421 local_error="${config}_ERROR"
422 local_error="${!local_error}"
423 [ -n "${local_error}" ] && eerror " ${local_error}" || \
424 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
425
426 for i in ${MODULE_NAMES}
427 do
428 n="${i//${temp_config}}"
429 [ -z "${n//(*}" ] && MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
430 done
431 error=0
432 fi
207 else 433 else
208 if ! getfilevar_isset ${config} ${KV_DIR}/.config ; 434 if ! linux_chkconfig_present ${config}
209 then 435 then
436 local_error="${config}_ERROR"
437 local_error="${!local_error}"
438 [ -n "${local_error}" ] && eerror " ${local_error}" || \
210 eerror " ${config}:\tshould be set in the kernel configuration, but isn't" 439 eerror " CONFIG_${config}:\tshould be set in the kernel configuration, but isn't"
211 error=1 440 error=1
212 fi 441 fi
213 fi 442 fi
214 done 443 done
215 444
216 if [ -n "${error}" ] ; 445 if [ "${error}" == 1 ] ;
217 then 446 then
218 eerror "Please check to make sure these options are set correctly." 447 eerror "Please check to make sure these options are set correctly."
219 eerror "Once you have satisfied these options, please try merging" 448 eerror "Once you have satisfied these options, please try merging"
220 eerror "this package again." 449 eerror "this package again."
221 die Incorrect kernel configuration options 450 die "Incorrect kernel configuration options"
222 fi 451 fi
223} 452}
224 453
225check_zlibinflate() { 454check_zlibinflate() {
226 # if we haven't determined the version yet, we need too. 455 # if we haven't determined the version yet, we need too.
258 487
259 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 488 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
260 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 489 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
261 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 490 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
262 (( LINENO_END = $LINENO_END - 1 )) 491 (( LINENO_END = $LINENO_END - 1 ))
263 SYMBOLS="$(head -n $LINENO_END ${KERNEL_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 492 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
264 493
265 # okay, now we have a list of symbols 494 # okay, now we have a list of symbols
266 # we need to check each one in turn, to see whether it is set or not 495 # we need to check each one in turn, to see whether it is set or not
267 for x in $SYMBOLS ; do 496 for x in $SYMBOLS ; do
268 if [ "${!x}" = "y" ]; then 497 if [ "${!x}" = "y" ]; then
289 eerror "Please remember to recompile and install your kernel, and reboot" 518 eerror "Please remember to recompile and install your kernel, and reboot"
290 eerror "into your new kernel before attempting to load this kernel module." 519 eerror "into your new kernel before attempting to load this kernel module."
291 520
292 die "Kernel doesn't include zlib support" 521 die "Kernel doesn't include zlib support"
293} 522}
523
524################################
525# Default pkg_setup
526# Also used when inheriting linux-mod to force a get_version call
527
528linux-info_pkg_setup() {
529 get_version || die "Unable to calculate Linux Kernel version"
530 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
531}

Legend:
Removed from v.1.3  
changed lines
  Added in v.1.20

  ViewVC Help
Powered by ViewVC 1.1.20